module Dag
  class Client
    module Cluster
      include Dag::Client::ClusterValidation

      attr_reader :cluster_name

      def open(cluster_name)
        @cluster_name = cluster_name
        self
      end

      def clusters
        Dag::ClusterCollection.new(@api)
      end

      def cluster
        if @cluster_name.blank?
          raise Dag::Client::ClusterNotOpen.new("cluster not opened")
        end
        cluster_status
        Dag::Cluster.new(@api, @cluster_info.merge("name" => @cluster_name))
      end
    end
  end
end
