module Dag
  class Client
    class APIFailure < StandardError
      attr_accessor :api_code
      attr_accessor :api_message
      attr_accessor :api_status
      attr_accessor :api_request_id
      attr_accessor :api_resource
    end

    # API
    class ParameterInvalid < StandardError
    end

    class APIOptionInvalid < StandardError
    end

    class StatusInvalid < StandardError
    end

    # Job
    class JobTypeInvalid < StandardError
    end

    # Cluster
    class ClusterNotOpen < StandardError
    end

    class ClusterRebooted < StandardError
    end

    # Database
    class DatabaseNotFound < StandardError
    end

    # Table
    class TableAlreadyExists < StandardError
    end

    class TableNotFound < StandardError
    end
  end
end
