module Dag
  class Client
    module JobValidation

      VALID_WHERE_KEYS = [
        :status,
        :type,
        :cluster_name,
        :label,
        :cluster_rebooted
      ]

      def validate_job_param_keys(params)
        params.keys.each do |k|
          unless VALID_WHERE_KEYS.include?(k.to_sym)
            raise Dag::Client::ParameterInvalid.new("Invalid where condition: #{k}")
          end
        end
      end
    end
  end
end
